import objective_function, algorithm


def exercise1():
    x_0 = 0
    for i in range(1000):
        x_0 += 0.1
        o_func = objective_function.ObjectiveFunction()
        gd = algorithm.GradientDescent(func=o_func.f_ex1, fprime=o_func.f_prime_ex1, x_0=x_0)

        for j in range(gd.max_iter):
            step_size = gd.armijo_step()
            gd.step(alpha=step_size)
            gd.num_iter += 1

        if abs(gd.p_k) < gd.tol:
            print('Result:\n  fx = {:.4f}\n  x = {:.4f}'.format(gd.f_k, gd.x_k))
            break


def exercise2(x_0):
    o_func = objective_function.ObjectiveFunction()
    gd = algorithm.GradientDescent(func=o_func.f_ex2, fprime=o_func.f_prime_ex2, x_0=x_0)

    for i in range(gd.max_iter):
        step_size = gd.armijo_step()
        gd.step(alpha=step_size)
        gd.num_iter += 1

    if gd.num_iter == gd.max_iter:
        print('Result:\n  not converge.')
    elif abs(gd.p_k) < gd.tol:
        print('Result:\n  y = {:.4f}\n  x = {:.4f}'.format(gd.f_k, gd.x_k))


if __name__ == "__main__":
    print("=" * 20, "Exercise 1", "=" * 20)
    exercise1()

    print("=" * 20, "Exercise 2", "=" * 20)
    exercise2(0.5)
    exercise2(2)